#include <SimpleKalmanFilter.h>
long result;   //variable for the result of the tx_rx measurement.
int analog_pin = 28; //  PA1 of the ATtiny412
int tx_pin = 4;  //     PA2 of the ATtiny412

SimpleKalmanFilter simpleKalmanFilter(2, 2, 0.01);
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,20,4); 

void setup() {
pinMode(tx_pin,OUTPUT);      //Pin 2 provides the voltage step
Serial.begin(115200);
  lcd.init();
  lcd.backlight();
}


long tx_rx(){         //Function to execute rx_tx algorithm and return a value
                      //that depends on coupling of two electrodes.
                      //Value returned is a long integer.
  int read_high;
  int read_low;
  int diff;
  long int sum;
  int N_samples = 100;    //Number of samples to take.  Larger number slows it down, but reduces scatter.

  sum = 0;

  for (int i = 0; i < N_samples; i++){
   digitalWrite(tx_pin,HIGH);              //Step the voltage high on conductor 1.
   read_high = analogRead(analog_pin);        //Measure response of conductor 2.
   delayMicroseconds(100);            //Delay to reach steady state.
   digitalWrite(tx_pin,LOW);               //Step the voltage to zero on conductor 1.
   read_low = analogRead(analog_pin);         //Measure response of conductor 2.
   diff = read_high - read_low;       //desired answer is the difference between high and low.
 sum += diff;                       //Sums up N_samples of these measurements.
 }
  return sum;
}                         //End of tx_rx function.


void loop() {

result = tx_rx();
result = map(result, 12000, 15000, 0, 1024);  //I recommend mapping the values of the two copper plates, it will depend on their size
//Serial.print(result);
//Serial.print(",");
float estimated_value = simpleKalmanFilter.updateEstimate(result);
result = map(estimated_value, 300, 6000, 0, 1024);
Serial.println(estimated_value);

if (estimated_value>0 && estimated_value<=610)
{
  lcd.setCursor(0,0);
  lcd.print("    _          _    ");
  lcd.setCursor(0,1);
  lcd.print("   / |         | \  ");
  lcd.setCursor(0,2);
  lcd.print("  /  |_________|   \ ");
  lcd.setCursor(0,3);
  lcd.print(" |________________| ");
  }

else if(estimated_value>610 && estimated_value<=653)
{

  lcd.setCursor(0,0);
  lcd.print("    _          _    ");
  lcd.setCursor(0,1);
  lcd.print("   / |         | \  ");
  lcd.setCursor(0,2);
  lcd.print("  /  |*********|   \ ");
  lcd.setCursor(0,3);
  lcd.print(" |________________| ");
  }
  
else if(estimated_value>653 && estimated_value<=680)
{
  lcd.setCursor(0,0);
  lcd.print("    _          _    ");
  lcd.setCursor(0,1);
  lcd.print("   / |*********| \  ");
  lcd.setCursor(0,2);
  lcd.print("  /  |*********|   \ ");
  lcd.setCursor(0,3);
  lcd.print(" |________________| ");
  }
  
else 
{
  lcd.setCursor(0,0);
  lcd.print("    _  ******  _    ");
  lcd.setCursor(0,1);
  lcd.print("   / |*********| \  ");
  lcd.setCursor(0,2);
  lcd.print("  /  |*********|   \ ");
  lcd.setCursor(0,3);
  lcd.print(" |________________| ");
  }
  
delay(1);
}
